## Oscillatory Hallucinations Filter

Author: Vikas Raunak (viraunak@microsoft.com)

## What type of a filter is this?
This filter is designed to operate in text generation systems' outputs, with the purpose of extracting oscillatory hallucinations. Oscillatory hallucinations are one class of hallucinations characterized by repeating bigram structure in the output [1]. Typically, these behaviors are observed in models trained on noisy corpora.

## Why is measuring performance on this split important?
This filter is designed to flag oscillatory hallucinations generated by a MT or a text generation system. It can be used a metric, i.e. how many oscillatory hallucinations did a system generate on a set of source sentences.

## Related Work
A thorough exposition of hallucinations is presented in the below paper.

```bibtex
@inproceedings{raunak-etal-2021-curious,
    title = "The Curious Case of Hallucinations in Neural Machine Translation",
    author = "Raunak, Vikas  and
      Menezes, Arul  and
      Junczys-Dowmunt, Marcin",
    booktitle = "Proceedings of the 2021 Conference of the North American Chapter of the Association for Computational Linguistics: Human Language Technologies",
    month = jun,
    year = "2021",
    address = "Online",
    publisher = "Association for Computational Linguistics",
    url = "https://aclanthology.org/2021.naacl-main.92",
    doi = "10.18653/v1/2021.naacl-main.92",
    pages = "1172--1183",
    abstract = "In this work, we study hallucinations in Neural Machine Translation (NMT), which lie at an extreme end on the spectrum of NMT pathologies. Firstly, we connect the phenomenon of hallucinations under source perturbation to the Long-Tail theory of Feldman, and present an empirically validated hypothesis that explains hallucinations under source perturbation. Secondly, we consider hallucinations under corpus-level noise (without any source perturbation) and demonstrate that two prominent types of natural hallucinations (detached and oscillatory outputs) could be generated and explained through specific corpus-level noise patterns. Finally, we elucidate the phenomenon of hallucination amplification in popular data-generation processes such as Backtranslation and sequence-level Knowledge Distillation. We have released the datasets and code to replicate our results.",
}
```
## What are the limitations of this filter?
It relies on two thresholds which are tuned to get high precision currently. More recall could be achieved by lowering the thresholds, at the cost of precision.
